<script setup>
import axios from "axios";
import { ref, onMounted, computed } from "vue";
import { useRouter } from "vue-router";

const orders = ref([]);
const userId = ref(1);
const router = useRouter();

// Date filter
const formatDate = (value) => {
  if (value) {
    const date = new Date(value);
    return date.toLocaleString();
  }
  return value;
};

const updateStatus = async (params) => {
  try {
    await axios.put(`http://localhost:8000/api/pesanan/${params.pesanan_id}`, {
      status: "succes",
    });
    router.go(0);
  } catch (error) {
    console.error("Error updating status:", error);
  }
};

const sortedOrders = computed(() => {
  // Sort orders by status, prioritizing 'pending' status
  return orders.value.sort((a, b) => {
    if (a.status === "pending" && b.status !== "pending") return -1;
    if (a.status !== "pending" && b.status === "pending") return 1;
    return b.pesanan_id - a.pesanan_id; // Also sort by pesanan_id in descending order
  });
});

const fetchOrderHistory = async () => {
  try {
    const pesananResponse = await axios.get(
      `http://localhost:8000/api/riwayatpesanan?user_id=${userId.value}`
    );
    const pesananList = pesananResponse.data.data;
    console.log(pesananList);
    const pesananDetailsList = {};

    for (let pesanan of pesananList) {
      const pesananId = pesanan.pesanan_id;

      const pesananDetailsResponse = await axios.get(
        `http://localhost:8000/api/pesanandetail?pesanan_id=${pesananId}`
      );
      pesananDetailsList[pesananId] = pesananDetailsResponse.data;
    }

    for (let pesanan of pesananList) {
      const pesananId = pesanan.pesanan_id;
      const pesananDetails = pesananDetailsList[pesananId];

      pesanan.books = [];

      for (let detail of pesananDetails) {
        const bukuId = detail.buku_id;

        const bukuResponse = await axios.get(
          `http://localhost:8000/api/buku/${bukuId}`
        );
        const buku = bukuResponse.data.bukus;

        if (pesananId === detail.pesanan_id) {
          pesanan.books.push({
            buku_id: bukuId,
            title: buku.title,
            cover: buku.cover,
            quantity: detail.qty,
            price: buku.price,
          });
        }
      }
    }

    orders.value = pesananList;
  } catch (error) {
    console.error("Error fetching order history:", error);
  }
};

onMounted(() => {
  fetchOrderHistory();

  return {
    sortedOrders,
    updateStatus
  };
});
</script>

<template>
  <section class="pt-5">
    <div class="container">
      <div class="row pt-5">
        <h1>Daftar Transaksi</h1>
        <div class="col">
          <div class="card mb-4" v-for="(pesananItems, index) in sortedOrders" :key="index">
            <div class="card-body mx-2">
              <div class="d-flex pb-3">
                <div class="text-left">
                  {{ formatDate(pesananItems.created_at) }}
                </div>
                <div class="text-center mx-4" :class="{
                  'text-warning': pesananItems.status === 'pending',
                  'text-success': pesananItems.status === 'success'
                }">
                  {{ pesananItems.status === 'pending' ? 'Menunggu Pembayaran' : 'Selesai' }}
                </div>
                <div class="text-left">
                  ID Pemesanan: {{ pesananItems.pesanan_id }}
                </div>
              </div>
              <table class="table table-borderless">
                <tbody>
                  <tr v-for="(buku, index) in pesananItems.books" :key="index" class="pb-3">
                    <th scope="row" style="width: 10%">
                      <img :src="buku.cover" class="card-img-top" style="object-fit: cover; object-position: center"
                        alt="" />
                    </th>
                    <td>
                      <div class="text-wrap">{{ buku.title }}</div>
                      <div class="text-wrap">
                        {{ buku.quantity }} x Rp {{ buku.price.toLocaleString("id-ID", { minimumFractionDigits: 2, }) }}
                      </div>
                    </td>
                  </tr>
                </tbody>
              </table>
              <div class="d-flex justify-content-between pb-2">
                <div>
                  <router-link v-if="pesananItems.status === 'succes'"
                    :to="{ path: `/invoice/${pesananItems.pesanan_id}` }" class="btn mx-2" style="
                      margin-top: auto;
                      text-align: center;
                      border-color: #0d6efd;
                      color: #0d6efd;
                    ">Lihat Invoice</router-link>
                  <!-- <router-link v-if="pesananItems.status === 'pending'" :to="{ name: 'pages.Order' }"
                  class=" btn btn-primary" style="text-align: center">Selesaikan Pembayaran</router-link> -->

                  <button v-if="pesananItems.status === 'pending'" @click="updateStatus(pesananItems, index)"
                    class=" btn btn-primary" style="text-align: center">Selesaikan Pembayaran</button>
                </div>
                <div>
                  <div class="card-text text-right">
                    Total Belanja Rp{{ pesananItems.total_amount.toLocaleString("id-ID", { minimumFractionDigits: 2, })
                    }}
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </section>
</template>
